//#define CLIENT_PROXY
using System;
using System.Security.Permissions;
using System.Data;

namespace RemotingExample.BusinessFacade
{
	
	public class SomeSystem : MarshalByRefObject
	{
		public SomeSystem()
		{
			#if (!CLIENT_PROXY)

			Console.WriteLine("System activated");

			#endif
		}
				

		[System.Security.Permissions.PrincipalPermissionAttribute(SecurityAction.Demand, Authenticated=true, Role = "Admin")]
		public  void DoAdminWork (string arg)
		{
			
			Console.WriteLine(DateTime.Now.ToString()+" : Recivied admin's message: " + arg);

			
		}

		[PrincipalPermissionAttribute(SecurityAction.Demand, Authenticated=true)]
		public  string PrintUserInfo()
		{
			string res = "";
			#if (!CLIENT_PROXY)
			System.Text.StringBuilder sb =  new System.Text.StringBuilder();
			sb.AppendFormat("User Login: {0}",Security.ServerSecurityContext.Current.Login);
			sb.AppendFormat(System.Environment.NewLine);
			sb.AppendFormat("User SessionID: {0}",Security.ServerSecurityContext.Current.SessionID.ToString());
			sb.AppendFormat(System.Environment.NewLine);
			sb.AppendFormat("User last activity: {0}",Security.ServerSecurityContext.Current.LastActivity.ToString());
			sb.AppendFormat(System.Environment.NewLine);
			res = sb.ToString();
			Console.WriteLine(DateTime.Now.ToString()+" :"+res);
			#endif
			return res;
		}
	
		[PrincipalPermissionAttribute(SecurityAction.Demand, Authenticated=true)]
		public  string  GetUserData()
		{
			#if (!CLIENT_PROXY)
				Console.WriteLine(DateTime.Now.ToString()+" :GetUserData " + Security.ServerSecurityContext.Current.Login);
			#endif
			return "Name";
			
			
		}

		[PrincipalPermissionAttribute(SecurityAction.Demand,  Authenticated=true)]
		public void Logout(string sid)
		{
			#if (!CLIENT_PROXY)

			Security.ServerSecurityContext.Current.Logout();
			Console.WriteLine(DateTime.Now.ToString()+" :User logout "+sid);

			#endif
		}

	
	}
}
