using System;
using System.Collections;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting;


namespace RemotingExample.Security
{

	public class ServerChannelSinkProvider : IServerChannelSinkProvider
	{
		public ServerChannelSinkProvider()
		{
			
		}

		public ServerChannelSinkProvider(IDictionary properties, ICollection providerData)
		{
			
		}


		public void GetChannelData(IChannelDataStore channelData)
		{
		}

		public IServerChannelSink CreateSink(IChannelReceiver channel)
		{
			IServerChannelSink nextSink = null;
			if (_next != null)
				nextSink = _next.CreateSink(channel);
			return new ServerChannelSink(nextSink);
		}

		public IServerChannelSinkProvider Next
		{
			get { return _next; }
			set { _next = value; }
		}


		private IServerChannelSinkProvider _next = null;
		
	} 

}