using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;

namespace RemotingExample.ConsoleServer
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Starter
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[MTAThread]
		static void Main(string[] args)
		{
			
			IChannel[] channels;
			Console.WriteLine(String.Format(".NET Version: {0}",System.Environment.Version));
			RemotingConfiguration.Configure("ConsoleServer.exe.config");
			channels = ChannelServices.RegisteredChannels;
			foreach (IChannel channel in channels)
			{
				Console.WriteLine(String.Format(DateTime.Now.ToString()+" :"+"Remoting chanel {0} initialized",channel.ChannelName.ToString()));
			}
			
			Console.WriteLine(DateTime.Now.ToString()+" :Server started!");
			
			Console.WriteLine("Press \"Enter\" for exit");
			Console.ReadLine();
			Console.WriteLine("Server stopping...");

			//Disposing
			//Dispose remoting channels
			channels = ChannelServices.RegisteredChannels;
			if  (channels!=null)
			{
				foreach (IChannel channel in channels)
				{
					ChannelServices.UnregisterChannel(channel);
				}
			}
			
			
			System.Environment.Exit(0);

		}
	}
}
