using System;
using System.Collections;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;
using System.Security.Principal;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Remoting;


namespace RemotingExample.Security
{
	
	public class ClientChannelSinkProvider : IClientChannelSinkProvider
	{   
	
		public ClientChannelSinkProvider()
		{
		}

		public ClientChannelSinkProvider(IDictionary properties, ICollection providerData)
		{
		}

	
		public IClientChannelSink CreateSink(IChannelSender channel, String url, Object remoteChannelData)
		{
			IClientChannelSink nextSink = null;
			if (_next != null)
			{
				nextSink = _next.CreateSink(channel, url, remoteChannelData);
				if (nextSink == null)
					return null;
			}

			return new ClientChannelSink(url, nextSink);
		}

		public IClientChannelSinkProvider Next
		{
			get { return _next; }
			set { _next = value; }
		}



		// data members
		private IClientChannelSinkProvider _next = null;
		
	} 
}
